﻿Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Text
Imports System.Windows.Forms
Imports System.IO.Ports


Public Class FrmStart
#Region "Member Variables"
    ' Local variables used to hold the present
    ' position as latitude and longitude

    Public Latitude As String
    Public Longitude As String

    'latitude, longitude and altitude averaging variables
    Enum AveType
        latitude = 0
        longitude = 1
        altitude = 2
    End Enum
    Public AAveraged(3) As Double       'Averaged value
    Public ATotal(3) As Double          'Running totals 
    Public ACount(3) As Integer         'Running count
    Public AOutRange(3) As Integer      'Check for out of range
    'If value is not within 10% then take value as new average
#End Region

#Region "Constructor"
    Public Sub New()
        ' This call is required by the Windows Form Designer.
        InitializeComponent()
        ' '' Try to open the serial port
        ''SerialPort1.Close()
        ''SerialPort1.PortName = "COM" + txtComPort.Text
        ''Try
        ''    SerialPort1.Open()
        ''Catch ex As Exception
        ''    MessageBox.Show(ex.Message)
        ''    Timer1.Enabled = False
        ''    btnUpdate.Text = "Update"
        ''    Return
        ''End Try
    End Sub
#End Region

    Private Sub RunningAve(ByVal AType As AveType, ByVal NextValue As Double)
        If AAveraged(AType) = 0 Then        'No average, use value
            AAveraged(AType) = NextValue
            ACount(AType) = 0
            AOutRange(AType) = 0          'Reset counter
            ATotal(AType) = 0
        ElseIf (NextValue < AAveraged(AType) * 0.95) Or (NextValue > AAveraged(AType) * 1.05) Then
            AOutRange(AType) += 1
            If AOutRange(AType) > 2 Then    'Assume average is bad and use value
                AAveraged(AType) = NextValue
                ACount(AType) = 0
                AOutRange(AType) = 0          'Reset counter
                ATotal(AType) = 0
            End If
        Else
            ATotal(AType) += NextValue
            ACount(AType) += 1
            AAveraged(AType) = ATotal(AType) / CDbl(ACount(AType))
            AOutRange(AType) = 0    'Reset AOutRange
        End If

        Select Case AType
            Case AveType.latitude
                txtLatAve.Text = AAveraged(AType).ToString
                txtLatSamp.Text = ACount(AType).ToString
            Case AveType.longitude
                txtLongAve.Text = AAveraged(AType).ToString
                txtLonSamp.Text = ACount(AType).ToString
            Case AveType.altitude
                txtAltFtAve.Text = AAveraged(AType).ToString("0.###")
                txtAltSamp.Text = ACount(AType).ToString
        End Select
    End Sub
    Private Sub ClearAverages()
        Dim i As Integer
        Timer1.Enabled = False
        For i = 0 To 2
            AAveraged(i) = 0
            ACount(i) = 0
            AOutRange(i) = 0
        Next
        txtLatSamp.Text = ""
        btnUpdate.Text = "Update"

    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If SerialPort1.IsOpen Then
            Dim data As String = SerialPort1.ReadExisting()
            Dim strArr() As String = data.Split("$")
            Dim degrees As Integer
            Dim decimaldegrees As Double
            Dim fullLat As Double
            Dim fullLon As Double
            Dim i As Integer = 0

            If strArr.Length > 1 Then
                Try
                    For i = 0 To strArr.Length
                        Dim strTemp As String = strArr(i)
                        Dim lineArr() As String = strTemp.Split(",")
                        If (lineArr(0) = "GPGGA") Then
                            Try
                                'Latitude
                                Dim dLat As Double =
                                 Convert.ToDouble(lineArr(2))
                                degrees = Int(dLat / 100)
                                decimaldegrees = (dLat - (100 * degrees)) / 60.0
                                fullLat = degrees + decimaldegrees
                                Latitude = lineArr(3).ToString() +
                                    fullLat.ToString(".######")
                                Call RunningAve(AveType.latitude, fullLat)

                                ' Longitude
                                Dim dLon As Double =
                                     Convert.ToDouble(lineArr(4))
                                degrees = Int(dLon / 100)
                                decimaldegrees = (dLon - (100 * degrees)) / 60.0
                                fullLon = degrees + decimaldegrees
                                Longitude = lineArr(5).ToString() +
                                    fullLon.ToString(".######")
                                Call RunningAve(AveType.longitude, fullLon)

                                ' Display
                                txtStatus.Text = "OK"
                                If lineArr(1).Length <> 0 Then
                                    txtTime.Text = lineArr(1)
                                End If
                                txtQuality.Text = lineArr(6)
                                txtSatellites.Text = lineArr(7)
                                txtHDOP.Text = lineArr(8)
                                txtAltitude.Text = lineArr(9)
                                Call RunningAve(AveType.altitude, Convert.ToDouble(lineArr(9)) * 3.28084)
                                txtAltUOM.Text = lineArr(10)
                                txtAltFt.Text = (Convert.ToDouble(lineArr(9)) * 3.28084).ToString("0.###")
                                txtLat.Text = Latitude
                                txtLong.Text = Longitude
                                 btnMapit.Enabled = True
                            Catch
                                ' Can't Read GPS values
                                txtStatus.Text = "GPGGA Bad"
                                btnMapit.Enabled = False
                            End Try
                        End If
                    Next
                Catch
                    'do nothing
                End Try
            End If
        Else
            txtLat.Text = "COM Port Closed"
            txtLong.Text = "COM Port Closed"
            btnMapit.Enabled = False
        End If

    End Sub

    Private Sub btnUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUpdate.Click
        ' cycle timer
        If Timer1.Enabled = True Then
            Timer1.Enabled = False
            btnUpdate.Text = "Update"
        Else
            Call ClearAverages()
            Timer1.Enabled = True
            btnUpdate.Text = "Stop Updates"
        End If
    End Sub

    Private Sub btnLook_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLook.Click
        Dim ComPort As Integer
        For ComPort = 1 To 20
            Try
                SerialPort1.Close()
                SerialPort1.PortName = "COM" + CStr(ComPort)
                SerialPort1.Open()
            Catch ex As Exception
                'MessageBox.Show(ex.Message, "COM" + CStr(ComPort))
            End Try

        Next
    End Sub

    Private Sub btnMapit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMapit.Click
        If Latitude <> String.Empty And Longitude <> String.Empty Then
            Dim f As New frmMap(Latitude, Longitude)
            f.Show()
        End If
    End Sub

    Private Sub txtComPort_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtComPort.TextChanged
        Try
            SerialPort1.Close()
            SerialPort1.PortName = "COM" + txtComPort.Text
            SerialPort1.Open()
        Catch ex As Exception
            'MessageBox.Show(ex.Message, "COM" + txtComPort.Text)
        End Try

    End Sub

    Private Sub btnPoint1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPoint1.Click
        txtLat1.Text = txtLatAve.Text
        txtLong1.Text = txtLongAve.Text
        txtAlt1.Text = txtAltFtAve.Text
        Call ClearAverages()
    End Sub

    Private Sub btnPoint2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPoint2.Click
        txtLat2.Text = txtLatAve.Text
        txtLong2.Text = txtLongAve.Text
        txtAlt2.Text = txtAltFtAve.Text
        Call ClearAverages()
    End Sub
    Private Sub btnPoint3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPoint3.Click
        txtLat3.Text = txtLatAve.Text
        txtLong3.Text = txtLongAve.Text
        txtAlt3.Text = txtAltFtAve.Text
        Call ClearAverages()
    End Sub

    Private Sub btnPoint4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPoint4.Click
        txtLat4.Text = txtLatAve.Text
        txtLong4.Text = txtLongAve.Text
        txtAlt4.Text = txtAltFtAve.Text
        Call ClearAverages()
    End Sub

    Private Sub btnCalculate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCalculate.Click

        Dim LatRad(4) As Double
        Dim LonRad(4) As Double
        Dim Radius As Double = 20925681.0   'Number of feet in radius of earth

        'Radians = degrees * (PI / 180)
        'If West or South then negative, not used in this program
        'Convert to decimal then radians
        'Distance = acos(cos(a1) * cos(b1) * cos(a2) * cos(b2) + cos(a1) * sin(b1) * cos(a2) * sin(b2) + sin(a1) * sin(a2)) * r
        'Distance = Math.Acos(Math.Cos(LatRad1) * Math.Cos(LonRad1) * Math.Cos(LatRad2) * Math.Cos(LonRad2) _
        '+ Math.Cos(LatRad1) * Math.Sin(LonRad1) * Math.Cos(LatRad2) _
        '* Math.Sin(LonRad2) + Math.Sin(LatRad1) * Math.Sin(LatRad2)) * Radius

        'Latitude and Longitudes for four points in radians
        Try
            LatRad(1) = CDbl(txtLat1.Text) * Math.PI / 180.0
            LonRad(1) = CDbl(txtLong1.Text) * Math.PI / 180.0
            LatRad(2) = CDbl(txtLat2.Text) * Math.PI / 180.0
            LonRad(2) = CDbl(txtLong2.Text) * Math.PI / 180.0
            LatRad(3) = CDbl(txtLat3.Text) * Math.PI / 180.0
            LonRad(3) = CDbl(txtLong3.Text) * Math.PI / 180.0
            LatRad(4) = CDbl(txtLat4.Text) * Math.PI / 180.0
            LonRad(4) = CDbl(txtLong4.Text) * Math.PI / 180.0
        Catch ex As Exception
            MessageBox.Show("Incorrect data entry!")
            Exit Sub
        End Try

        'Calculate Bottom 1 to 2
        txtDistBot.Text = (CalDistance(LatRad(1), LonRad(1), LatRad(2), LonRad(2))).ToString("#,##0.00")
        txtRiseBot.Text = ((CDbl(txtAlt2.Text) - CDbl(txtAlt1.Text))).ToString("#.#")
        txtBearingBot.Text = _
            (CalBearing(LatRad(1), LonRad(1), LatRad(2), LonRad(2))).ToString("#.#")

        'Calculate Left 1 to 3
        txtDistLeft.Text = (CalDistance(LatRad(1), LonRad(1), LatRad(3), LonRad(3))).ToString("#,##0.00")
        txtRiseLeft.Text = (CDbl(txtAlt3.Text) - CDbl(txtAlt1.Text)).ToString("#.#")
        txtBearingLeft.Text = _
            (CalBearing(LatRad(1), LonRad(1), LatRad(3), LonRad(3))).ToString("#.#")

        'Calculate Top 3 to 4
        txtDistTop.Text = (CalDistance(LatRad(3), LonRad(3), LatRad(4), LonRad(4))).ToString("#,##0.00")
        txtRiseTop.Text = (CDbl(txtAlt4.Text) - CDbl(txtAlt3.Text)).ToString("#.#")
        txtBearingTop.Text = _
            (CalBearing(LatRad(3), LonRad(3), LatRad(4), LonRad(4))).ToString("#.#")

        'Calculate Right 2 to 4
        txtDistRight.Text = (CalDistance(LatRad(2), LonRad(2), LatRad(4), LonRad(4))).ToString("#,##0.00")
        txtRiseRight.Text = (CDbl(txtAlt4.Text) - CDbl(txtAlt2.Text)).ToString("#.#")
        txtBearingRight.Text = _
            (CalBearing(LatRad(2), LonRad(2), LatRad(4), LonRad(4))).ToString("#.#")

    End Sub
    Public Function CalDistance(ByVal Lat1 As Double, ByVal Lon1 As Double, ByVal Lat2 As Double, ByVal Lon2 As Double) As Double
        ' ''Dim Radius As Double = 20925681.0   'Number of feet in radius of earth
        Dim Radius As Double = 20902231.0   'Number of feet in radius of earth, based on 6371kM

        'Haversine Formula
        Dim dLat As Double = Lat2 - Lat1
        Dim dLong As Double = Lon2 - Lon1
        Dim a As Double = Math.Sin(dLat / 2.0) * Math.Sin(dLat / 2.0) + _
            Math.Cos(Lat1) * Math.Cos(Lat2) * Math.Sin(dLong / 2.0) * Math.Sin(dLong / 2.0)
        Dim c As Double = 2.0 * Math.Atan2(Math.Sqrt(a), Math.Sqrt(1.0 - a))
        CalDistance = Radius * c

        'This must be a Spherical Law of Cosines 
        ' ''CalDistance = Math.Acos(Math.Cos(Lat1) * Math.Cos(Lon1) * Math.Cos(Lat2) * Math.Cos(Lon2) _
        ' ''+ Math.Cos(Lat1) * Math.Sin(Lon1) * Math.Cos(Lat2) _
        ' ''* Math.Sin(Lon2) + Math.Sin(Lat1) * Math.Sin(Lat2)) * Radius


    End Function
    Public Function CalBearing(ByVal Lat1 As Double, ByVal Lon1 As Double, ByVal Lat2 As Double, ByVal Lon2 As Double) As Double
        Dim BearingRad As Double

        BearingRad = Math.Atan2((Math.Sin(Lon2 - Lon1) * Math.Cos(Lat2)), _
                    Math.Cos(Lat1) * Math.Sin(Lat2) - Math.Sin(Lat1) * _
                    Math.Cos(Lat2) * Math.Cos(Lon2 - Lon1))
       
        'Radians = degrees * (PI / 180)  degrees = 180 * radians/pi
        CalBearing = 180.0 * BearingRad / Math.PI
        'Normalize)        'CalBearing = (CalBearing + 360)%360
        CalBearing = (CalBearing + 360.0) Mod 360.0

    End Function
    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        saveFD.InitialDirectory = "C:\Documents and Settings\Michael\My Documents"
        saveFD.Filter = "Text Files|*.txt"
        saveFD.ShowDialog()

        Dim strFileName As String
        strFileName = saveFD.FileName

        Dim objWriter As New System.IO.StreamWriter(strFileName)
        objWriter.WriteLine("Point, Latitude, Longitude, Altitude")
        objWriter.WriteLine("NW Point, " + txtLat3.Text + ", " + _
                            txtLong3.Text + ", " + txtAlt3.Text)
        objWriter.WriteLine("NE Point, " + txtLat4.Text + ", " + _
                            txtLong4.Text + ", " + txtAlt4.Text)
        objWriter.WriteLine("SW Point, " + txtLat1.Text + ", " + _
                            txtLong1.Text + ", " + txtAlt1.Text)
        objWriter.WriteLine("SE Point, " + txtLat2.Text + ", " + _
                            txtLong2.Text + ", " + txtAlt2.Text)
        objWriter.WriteLine()
        objWriter.WriteLine("Point to Point, Distance, Direction, Rise(ft)")
        objWriter.WriteLine("Top, " + txtDistTop.Text + _
                ", " + txtBearingTop.Text + ", " + txtRiseTop.Text)
        objWriter.WriteLine("Right, " + txtDistRight.Text + _
                ", " + txtBearingRight.Text + ", " + txtRiseRight.Text)
        objWriter.WriteLine("Bottom, " + txtDistBot.Text + _
                ", " + txtBearingBot.Text + ", " + txtRiseBot.Text)
        objWriter.WriteLine("Left, " + txtDistLeft.Text + _
                ", " + txtBearingLeft.Text + ", " + txtRiseLeft.Text)
        objWriter.Close()

    End Sub

    Private Sub FrmStart_Leave(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Leave
        SerialPort1.Close()
    End Sub
End Class